<?php

namespace MoniContract\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Next ServiceType
 * @subpackage Services
 */
class Next extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named NextSigner
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \MoniContract\StructType\NextSigner $parameters
     * @return \MoniContract\StructType\NextSignerResponse|bool
     */
    public function NextSigner(\MoniContract\StructType\NextSigner $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->NextSigner($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \MoniContract\StructType\NextSignerResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
