<?php

namespace MoniContract\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthenticationResult2 StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:AuthenticationResult2
 * @subpackage Structs
 */
class AuthenticationResult2 extends AuthenticationResult
{
    /**
     * The Discounts
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \MoniContract\ArrayType\ArrayOfProgramDiscounts
     */
    public $Discounts;
    /**
     * The NonSolicitSigned
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $NonSolicitSigned;
    /**
     * Constructor method for AuthenticationResult2
     * @uses AuthenticationResult2::setDiscounts()
     * @uses AuthenticationResult2::setNonSolicitSigned()
     * @param \MoniContract\ArrayType\ArrayOfProgramDiscounts $discounts
     * @param bool $nonSolicitSigned
     */
    public function __construct(\MoniContract\ArrayType\ArrayOfProgramDiscounts $discounts = null, $nonSolicitSigned = null)
    {
        $this
            ->setDiscounts($discounts)
            ->setNonSolicitSigned($nonSolicitSigned);
    }
    /**
     * Get Discounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \MoniContract\ArrayType\ArrayOfProgramDiscounts|null
     */
    public function getDiscounts()
    {
        return isset($this->Discounts) ? $this->Discounts : null;
    }
    /**
     * Set Discounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \MoniContract\ArrayType\ArrayOfProgramDiscounts $discounts
     * @return \MoniContract\StructType\AuthenticationResult2
     */
    public function setDiscounts(\MoniContract\ArrayType\ArrayOfProgramDiscounts $discounts = null)
    {
        if (is_null($discounts) || (is_array($discounts) && empty($discounts))) {
            unset($this->Discounts);
        } else {
            $this->Discounts = $discounts;
        }
        return $this;
    }
    /**
     * Get NonSolicitSigned value
     * @return bool|null
     */
    public function getNonSolicitSigned()
    {
        return $this->NonSolicitSigned;
    }
    /**
     * Set NonSolicitSigned value
     * @param bool $nonSolicitSigned
     * @return \MoniContract\StructType\AuthenticationResult2
     */
    public function setNonSolicitSigned($nonSolicitSigned = null)
    {
        // validation for constraint: boolean
        if (!is_null($nonSolicitSigned) && !is_bool($nonSolicitSigned)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nonSolicitSigned)), __LINE__);
        }
        $this->NonSolicitSigned = $nonSolicitSigned;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \MoniContract\StructType\AuthenticationResult2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
